import { defineConfig } from 'vitepress'

import { getSidebar } from 'vitepress-plugin-auto-sidebar'


// https://vitepress.dev/reference/site-config
export default defineConfig({
  base: './',
  title: 'webDevStandard',
  description: '前端开发规范',
  themeConfig: {
    // https://vitepress.dev/reference/default-theme-config
    socialLinks: [{ icon: 'github', link: 'https://git.081024.xyz/hxx/devStandard' }],
    search: {
      provider: 'local'
    },
    outlineTitle: '页面导航',
    docFooter: {
      prev:"上一页",
      next:"下一页",
    },
    outline: {level: [2,6]},

    nav: [
      { text: '首页', link: '/' },
      { text: '开发规范', link: '/devStandard/前端/1-目录' },
      { text: '面试复习', link: '/learning/1-html/1-html基础' },
    ],

    sidebar: {
      '/devStandard': getSidebar({
        contentRoot: '/docs',
        contentDirs: ['devStandard'],
        collapsible: true,
        collapsed: true,
      }),
      '/learning': getSidebar({
        contentRoot: '/docs',
        contentDirs: ['learning'],
        collapsible: true,
        collapsed: true
      }),
    },
  },
  vite: {
    assetsInclude: ['**/*.jpg', '**/*.png', '**/*.gif', '**/*.zip', '**/*.pdf','**/*.webp'],
    plugins: []
  },
  ignoreDeadLinks: true,
})
